//***************************************************************************
// Simple SPI master-slave hello world example
// Designed for all avr mega/tiny types. 
// When in doubt, double check the pins
//
// @author Amir Lazarovich
// @version 0.1 2013
//**************************************************************************
#include "libs/avr-io.h"
#include "libs/usart.h"
#include "libs/spi.h"
#include <util/delay.h>

#define BAUD 9600L
#define BUFFER_SIZE 128

char buffer[BUFFER_SIZE];


int main (void) {
        disableClockPrescaling();
        USART_initSerial(F_CPU, BAUD); 
        SPI_initSlave();

        // must come after initializing the USART serial and making sure the clock prescaler is set to 1 
        printf("\n*** SLAVE mode ***\n");
        
        // loop
        static int status;
        while (1) {
            if (SPI_isReceiveReady()) {
                status = SPI_receive(buffer, BUFFER_SIZE);
                if (status == SUCCESS) {
                    printf("received: %s\n", buffer);    
                } else {
                    printf("transmission failure!\n");
                }
            }
        }
}